Update TODO
[grml-debootstrap.git] / grml-debootstrap
1 #!/bin/sh
2 # Filename:      grml-bootstrap
3 # Purpose:       wrapper around debootstrap for installing plain Debian via grml
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 # Latest change: Die Jun 05 14:23:38 CEST 2007 [mika]
8 ################################################################################
9 # http://www.debian.org/releases/stable/i386/index.html.en
10
11 set -e # exit on any error
12
13 VERSION='0.10'
14
15 # source core functions {{{
16 . /etc/grml/lsb-functions
17 . /etc/grml/script-functions
18 # }}}
19
20 # make sure we have what we need {{{
21 check4progs debootstrap || exit 1
22 check4root || exit 1
23 # }}}
24
25 # without config file it won't work {{{
26 if [ -r /etc/debootstrap/config ] ; then
27    . /etc/debootstrap/config
28 else
29    eerror "/etc/debootstrap/config could not be read, exiting." ; eend 1
30    exit 1
31 fi
32 # }}}
33
34 # cmdline handling {{{
35 usage() {
36   einfo "$0 - version $VERSION"
37   echo  "   A wrapper around debootstrap for installing plain Debian via grml"
38   echo
39   einfo "Usage: $0 [options]"
40   echo  "   Adjust /etc/debootstrap/config and invoke $0 afterwards or use the cmdline option:"
41   echo
42   einfo "Valid options:"
43   echo  "
44     -h|--help                   Print this usage information and exit.
45     -v|--version                Show summary of options and exit.
46
47     -t|--target <target>        Target partition (/dev/...) or directory.
48     -r|--release <release>      Specify release of new Debian system. Supported relases: sarge, etch, lenny and sid.
49     -m|--mirror <URL>           Specify mirror which should be used for apt-get/aptitude.
50     -i|--iso <mnt>              Specify mountpoint where Debian ISO is mounted to (instead of using mirror)
51     -p|--mntpoint <mnt>         Specify mountpoint that should be used for mounting the target system.
52     --groot <device>            Specify root device for usage in grub (corresponds with \$TARGET).
53     --grub <device>             Where do you want to install grub to? Use grub syntax for specifying.
54     --password <pwd>            Use specified password as password for user root. Use with caution.
55     --boot_append <appendline>  Add specified appendline to kernel whilst booting
56
57 "
58 }
59
60 while [ "$#" -gt "0" ] ; do
61     case $1 in
62         -v|--version)
63             einfo "$0 - version $VERSION"
64             einfo "Send bug reports to Michael Prokop <mika@grml.org>."
65             eend 0
66             exit 0
67             ;;
68         -t|--target)
69             shift
70             TARGET=$1
71             ;;
72         --grub)
73             shift
74             GRUB=$1
75             ;;
76         --groot)
77             shift
78             GROOT=$1
79             ;;
80         --release)
81             shift
82             RELEASE=$1
83             ;;
84         -p|--mntpoint)
85             shift
86             MNTPOINT=$1
87             ;;
88         --password)
89             shift
90             ROOTPASSWORD=$1
91             ;;
92         -m|--mirror)
93             shift
94             MIRROR=$1
95             CHROOTMIRROR=$1
96             ;;
97         -i|--iso)
98             shift
99             [ -n "$MIRROR" ] && unset MIRROR
100             ISO=$1
101             ;;
102         -h|--help)
103             usage ; eend 0
104             eend 0
105             exit 0
106             ;;
107         *)
108             eerror "Syntax error."
109             usage ; eend 1
110             exit 1
111             ;;
112     esac
113     shift
114 done
115 # }}}
116
117 # set/check variables {{{
118
119 # inside the chroot system the locales might not be available, so use minimum:
120 export LANG=C
121 export LC_ALL=C
122
123 if [ -z "$STAGES" ] ; then
124    STAGES='/etc/debootstrap/stages'
125    [ -d "$STAGES" ] || mkdir -p "$STAGES"
126 fi
127
128 if [ -r $STAGES/grml-debootstrap ] ; then
129    if grep -q done $STAGES/grml-debootstrap ; then
130       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
131       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}" ; eend 1
132    fi
133 fi
134
135 PARTITION=''
136 DIRECTORY=''
137
138 case $TARGET in
139   /dev/*)
140     PARTITION=1
141     ;;
142   *)
143     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
144     DIRECTORY=1
145     MNTPOINT="$TARGET"
146     MKFS=''
147     TUNE2FS=''
148     FSCK=''
149     GRUB=''
150     GROOT=''
151     ;;
152 esac
153
154 if [ -n "$ARCH" ] ; then
155    ARCHCMD="--arch $ARCH"
156    ARCHINFO=" (${ARCH})"
157 else
158    ARCH="$(dpkg --print-architecture)"
159    ARCHCMD="--arch $ARCH"
160    ARCHINFO=" (${ARCH})"
161 fi
162
163 # make sure we have the right syntax when using an iso image
164 case $ISO in
165    file*) # do nothing
166     ;;
167    *)
168     ISO=file:$1
169     ;;
170 esac
171 ISODIR=${ISO##file:}
172 ISODIR=${ISODIR%%/}
173
174 # provide variables to chroot system
175 touch /etc/debootstrap/variables
176 chmod 600 /etc/debootstrap/variables # make sure nobody except root can read it
177 [ -n "$ARCH" ]   && echo "ARCH=$ARCH"     >  /etc/debootstrap/variables
178 [ -n "$GRUB" ]   && echo "GRUB=$GRUB"     >> /etc/debootstrap/variables
179 [ -n "$GROOT" ]  && echo "GROOT=$GROOT"   >> /etc/debootstrap/variables
180 [ -n "$TARGET" ] && echo "TARGET=$TARGET" >> /etc/debootstrap/variables
181 [ -n "$ISO" ]    && echo "ISO=$ISO"       >> /etc/debootstrap/variables
182 [ -n "$ISODIR" ] && echo "ISODIR=$ISO"    >> /etc/debootstrap/variables
183 [ -n "$MIRROR" ] && echo "MIRROR=$MIRROR" >> /etc/debootstrap/variables
184 [ -n "$MIRROR" ] && echo "CHROOTMIRROR=$MIRROR" >> /etc/debootstrap/variables
185 [ -n "$ROOTPASSWORD" ] && echo "ROOTPASSWORD=$ROOTPASSWORD" >> /etc/debootstrap/variables
186
187 # make sure at least $TARGET is set [the partition for the new system]
188 if [ -z "$TARGET" ] ; then
189    eerror "Please adjust /etc/debootstrap/config before running ${0}" ; eend 1
190    exit 1
191 fi
192 # }}}
193
194 # helper functions {{{
195 # we want to exit smoothly and clean:
196 bailout(){
197   # make sure $TARGET is not mounted when exiting grml-debootstrap
198   if [ -n "$MNTPOINT" ] ; then
199      if grep -q $MNTPOINT /proc/mounts ; then
200         # make sure nothing is left inside chroot so we can unmount it
201         [ -x "$MNTPOINT"/etc/init.d/ssh   ] && "$MNTPOINT"/etc/init.d/ssh stop
202         [ -x "$MNTPOINT"/etc/init.d/mdadm ] && "$MNTPOINT"/etc/init.d/mdadm stop
203         # ugly, but make sure we really don't leav anything
204         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /sys  1>/dev/null 2>&1
205         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a    1>/dev/null 2>&1
206         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
207         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
208         [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" 1>/dev/null 2>&1
209         einfo "Unmounting $MNTPOINT" ; umount "$MNTPOINT" ; eend $?
210      fi
211   fi
212   [ -n "$1" ] && EXIT="$1" || EXIT="1"
213   [ -n "$3" ] && einfo "Notice: just remove $STAGES/$3 to reexecute the stage"
214   exit "$EXIT"
215 }
216 trap bailout 1 2 3 15
217
218 # we want to execute all the functions only once, simple check for it:
219 stage() {
220   if [ -n "$2" ] ; then
221      echo "$2" > "$STAGES/$1"
222      return 0
223   elif grep -q done "$STAGES/$1" 2>/dev/null ; then
224      ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
225      return 1
226   fi
227 }
228 # }}}
229
230 # user should recheck his configuration {{{
231 # support full automatic installation:
232 checkforrun() {
233    dialog --timeout 10 --title "$0" \
234           --yesno "Do you want to stop at this stage?
235
236 Notice: you are running grml-debootstrap in non-interactive mode.
237 grml-debootstrap will install Debian ${RELEASE} on ${TARGET}.
238 Last chance to quit. Timeout of 10 seconds running....
239
240 Do you want to stop now?" 0 0 2>/dev/null
241 }
242
243 if [ -n "$AUTOINSTALL" ] ; then
244    if checkforrun ; then
245       eerror "Exiting as requested" ; eend 0
246       exit 1
247    fi
248 else # if not running automatic installation display configuration and prompt for execution:
249    einfo "$0 - Please recheck configuration before execution:"
250    echo
251    echo "   Target:           $TARGET"
252       case "$MNTPOINT" in "$TARGET") ;; *) echo "   Mount-point:      $MNTPOINT" ;; esac
253       [ -n "$GRUB" ]   && echo "   Install grub to:  $GROOT / $GRUB"
254       [ -n "$MIRROR" ] && echo "   Using mirror:     $MIRROR"
255       [ -n "$ISO" ] && echo "   Using iso:        $ISO"
256       case "$MNTPOINT" in "$TARGET") ;; *) echo "   Important! Continuing will delete all data from ${TARGET}!" ;; esac
257       echo
258    einfon "Is this ok for you? [y/N] "
259    read a
260    if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
261       eerror "Exiting as requested." ; eend 1
262       exit 1
263    fi
264 fi
265 # }}}
266
267 # create filesystem {{{
268 mkfs() {
269   if [ -n "$MKFS" ] ; then
270      einfo "Running $MKFS on $TARGET"
271      $MKFS $TARGET
272      eend $?
273   fi
274 }
275 # }}}
276
277 # modify filesystem settings {{{
278 tunefs() {
279   if [ -n "$TUNE2FS" ] ; then
280      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
281      $TUNE2FS $TARGET
282      eend $?
283   fi
284 }
285 # }}}
286
287 # mount the new partition or if it's a directory do nothing at all {{{
288 mount_target() {
289   if [ -n "$DIRECTORY" ] ; then
290      einfo "Running grml-debootstrap on a directory, nothing to mount."
291   else
292      if grep -q $TARGET /proc/mounts ; then
293         eerror "$TARGET already mounted, exiting."
294      else
295        [ -n "$MNTPOINT" ] || MNTPOINT='/mnt/test'
296        [ -d "$MNTPOINT" ] || mkdir -p "$MNTPOINT"
297        einfo "Mounting $TARGET to $MNTPOINT"
298        mount -o rw,suid,dev $TARGET $MNTPOINT
299        eend $?
300      fi
301   fi
302   if [ -n "$ISODIR" ] ; then
303      einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
304      mkdir -p "$MNTPOINT/$ISODIR"
305      mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
306      eend $?
307   fi
308 }
309 # }}}
310
311 # install main chroot {{{
312 debootstrap_system() {
313   if ! grep -q $MNTPOINT /proc/mounts ; then
314           mount_target
315   fi
316   if grep -q $MNTPOINT /proc/mounts ; then
317      einfo "Running $DEBOOTSTRAP for release ${RELEASE}${ARCHINFO} using ${MIRROR}${ISO}"
318      [ -n "$MIRROR" ] && $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $MIRROR || \
319      $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $ISO
320      eend $?
321   else
322      eerror "Error: $MNTPOINT not mounted, can not continue."
323      eend 1
324   fi
325 }
326 # }}}
327
328 # prepare chroot via chroot-script {{{
329 preparechroot() {
330   einfo "Preparing chroot system"
331   cp $CONFFILES/chroot-script $MNTPOINT/bin/chroot-script
332   chmod 755 $MNTPOINT/bin/chroot-script
333   mkdir $MNTPOINT/etc/debootstrap/
334
335   # make sure we have our files for later use via chroot-script
336   cp /etc/debootstrap/config          $MNTPOINT/etc/debootstrap/
337   cp /etc/debootstrap/packages        $MNTPOINT/etc/debootstrap/packages
338   cp /etc/debootstrap/variables       $MNTPOINT/etc/debootstrap/variables
339
340   cp -a /etc/debootstrap/extrapackages/ $MNTPOINT/etc/debootstrap/
341
342   # make sure we can access network [relevant for cdebootstrap]
343   [ -f "$MNTPOINT/etc/resolv.conf" ] || cp /etc/resolv.conf $MNTPOINT/etc/resolv.conf
344
345   # setup default locales
346   [ -n "$LOCALES" ] && cp /etc/debootstrap/locale.gen  $MNTPOINT/etc/locale.gen
347
348   # copy any existing existing files to chroot
349   [ -d /etc/debootstrap/boot  ] && cp -a /etc/debootstrap/boot/*  $MNTPOINT/boot/
350   [ -d /etc/debootstrap/etc   ] && cp -a /etc/debootstrap/etc/*   $MNTPOINT/etc/
351   [ -d /etc/debootstrap/share ] && cp -a /etc/debootstrap/share/* $MNTPOINT/share/
352   [ -d /etc/debootstrap/usr   ] && cp -a /etc/debootstrap/usr/*   $MNTPOINT/usr/
353   [ -d /etc/debootstrap/var   ] && cp -a /etc/debootstrap/var/*   $MNTPOINT/var/
354   eend 0
355 }
356 # }}}
357
358 # execute chroot-script {{{
359 chrootscript() {
360   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
361      mount_target
362   fi
363   if [ -x "$MNTPOINT/bin/chroot-script" ] ; then
364      einfo "Executing chroot-script now"
365      chroot "$MNTPOINT" /bin/chroot-script
366      eend $?
367   else
368      eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
369      eend 1
370   fi
371 }
372 # }}}
373
374 # install booloader grub {{{
375 grub_install() {
376   if [ -z "$GRUB" -o -z "$GROOT" ] ; then
377      echo "Notice: \$GRUB or \$GROOT not defined, will not install grub therefor."
378   else
379      einfo "Installing grub on ${GRUB}:"
380      [ -x /usr/sbin/grub-install ] && GRUBINSTALL=/usr/sbin/grub-install || GRUBINSTALL=/sbin/grub-install
381      $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
382      eend $?
383   fi
384 }
385 # }}}
386
387 # unmount $MNTPOINRT {{{
388 umount_chroot() {
389   if [ -n "$ISODIR" ] ; then
390      if grep -q "$ISODIR" /proc/mounts ; then
391         einfo "Unmount $MNTPOINT/$ISODIR"
392         umount "$MNTPOINT/$ISODIR"
393         eend $?
394      fi
395   fi
396   if grep -q "$MNTPOINT" /proc/mounts ; then
397      if [ -n "$PARTITION" ] ; then
398         einfo "Unmount $MNTPOINT"
399         umount $MNTPOINT
400         eend $?
401      fi
402   fi
403 }
404 # }}}
405
406 # execute filesystem check {{{
407 fscktool() {
408   if [ "$FSCK" = 'yes' ] ; then
409      [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
410      einfo "Checking filesystem on $TARGET using $FSCKTOOL"
411      $FSCKTOOL $TARGET
412      eend $?
413   fi
414 }
415 # }}}
416
417 # now execute all the functions {{{
418 for i in mkfs tunefs mount_target debootstrap_system preparechroot \
419          chrootscript grub_install umount_chroot fscktool ; do
420     if stage $i ; then
421        $i && stage $i done || bailout 2 "i"
422     fi
423 done
424 # }}}
425
426 # stages {{{
427   echo done > $STAGES/grml-debootstrap
428 # }}}
429
430 if [ -n "$AUTOINSTALL" ] ; then
431    dialog --title "$0" --msgbox \
432           "Finished execution of ${0}.
433 Enjoy your Debian system." 6 60
434 else
435    einfo "Finished execution of $0 - enjoy your Debian system." ; eend 0
436 fi
437
438 ## END OF FILE #################################################################
439 # vim: ai tw=100 expandtab foldmethod=marker